<script setup>
import { ref, watch, computed } from 'vue'
import { useRouter } from 'vue-router'
import { storeToRefs } from 'pinia'

// Import state management store
import { useInstrumentStore } from '../../stores/instrument.js'

// UI stuff
import { CdxField, CdxTextInput, CdxRadio, CdxLookup } from '@wikimedia/codex';

// Import composables
import useUtility from '../../composables/utility.js';

const router = useRouter()
const instrumentStore = useInstrumentStore();
const { getSlugFormatted } = useUtility()
const { instrument, formFunction } = storeToRefs(instrumentStore);
const startingInstrumentName = ref( );

watch(instrument, (newInstrument) => {
    if (newInstrument.name) return
    // only clear the input value if the name is blank (doesn't do it by itself)
    // TODO: check this
    //if (instrumentLookup.value) {
    //    instrumentLookup.value.inputValue = newInstrument.name;
    //}
});
// Watch for changes on radioFunctionValue to refresh instruments
watch(formFunction, async (newFunction) => {
    switch(newFunction) {
        case 'new':
            instrumentStore.setInstrument();
            if (instrumentStore.isABTest) {
                router.push('/create-experiment')
            } else {
                router.push('/create-instrument')
            }
            break;
        case 'template':
            instrumentStore.setInstrument();
            router.push('/template')
            break;
    }
});

// Watch for changes on instrument name to populate formatted slug
watch(
    () => instrumentStore.instrument.name,
    (name) => {
        instrumentStore.instrument.slug = getSlugFormatted(name);
    }
);

// To populate the instrument search dropdown.
const instrumentFilter = ref( [] );
const menuItems = computed(() => instrumentStore.instrumentsMenu.filter( ( item ) => {
    return item.label.toLowerCase().includes( instrumentFilter.value );
}));
const menuConfig = {
    boldLabel: true
};

/**
 * Get the slug based on instrument id.
 *
 * @param {integer} id
 */
 function getSlug(id) {
    const matchingItem = instrumentStore.instrumentsMenu.find((item) => item.value === id);
    return matchingItem ? matchingItem.slug : '';
}

/**
 * Filter items on input.
 *
 * @param {string} value
 */
function onChangeInstrumentName( value ) {
    if ( value ) {
        instrumentFilter.value = value;
        instrumentStore.instrument.name = value;
    }
}

/**
 * Prepopulate form on input.
 *
 * @param {string} value
 */
function onSelection( value ) {
    const newSlug = getSlug(value)
    instrumentStore.setInstrument(newSlug)
}

// Function for new or existing instrument
const radiosInstrumentFunction = [
    {
        label: 'Configure new A/B test',
        value: 'new'
    },
    {
        label: 'Use existing as template',
        value: 'template'
    }
];
</script>

<template>
    <h2>Get Started</h2>
        <!-- GET STARTED: Function -->
        <cdx-field :is-fieldset="true">
            <template #label>
                What would you like to do?
            </template>
            <cdx-radio
                v-for="radio in radiosInstrumentFunction"
                :key="'radio-' + radio.value"
                v-model="instrumentStore.formFunction"
                name="radio-group-instrument-function"
                :input-value="radio.value"
                data-id="instrument-function"
            >
                {{ radio.label }}
                <template #description>
                    {{ radio.description }}
                </template>
            </cdx-radio>
        </cdx-field>
    <br/>
    <!-- GET STARTED: Instrument and Machine-readable name -->
    <div v-if="instrumentStore.isTemplateFunction">
        <cdx-field>
            <cdx-lookup
                v-model:selected="instrumentStore.instrument.id"
                :input-value="instrumentStore.instrument.name"
                :menu-items="menuItems"
                :menu-config="menuConfig"
                aria-label="Starting instrument"
                @input="onChangeInstrumentName"
                @update:selected="onSelection"
            ></cdx-lookup>
            <template #label>
                Select template {{ instrumentStore.instrument.type }}
            </template>
            <template #description>
                Select an existing {{ instrumentStore.instrument.type }} to use as a template for your new configuration
            </template>
        </cdx-field>
    </div>
    <div>
        <div class="column" v-if="instrumentStore.isNewFunction">
            <cdx-field>
                <cdx-text-input 
                    v-model="instrumentStore.instrument.name"
                    data-id="instrument-name-new"
                />
                <template #label>
                    {{ instrumentStore.instrument.type }} name
                </template>
                <template #description>
                    Add the name of the {{ instrumentStore.instrument.type }}, as documented in the measurement plan. This cannot be modified later.
                </template>
            </cdx-field>
        </div>
        <div class="column" v-if="instrumentStore.isTemplateFunction">
            <cdx-field>
                <cdx-text-input
                    v-model="instrumentStore.instrument.name"
                    data-id="instrument-name-template"
                />
                <template #label>
                    New name
                </template>
                <template #description>
                    Add the name of the {{ instrumentStore.instrument.type }}, as documented in the measurement plan. This cannot be modified later.
                </template>
            </cdx-field>
        </div>
        <div class="column right uneven">
            <cdx-field>
                <cdx-text-input
                    v-model="instrumentStore.instrument.slug" :readonly="true"
                    data-id="instrument-slug"
                />
                <template #label>
                    Machine-readable name
                </template>
                <template #description>
                    Auto-generated name required by the system. <br />This cannot be edited.
                </template>
            </cdx-field>
        </div>
    </div>
    <div class="clearfix"></div>
</template>

<style scoped>
.sectiontitle {
    width: 100%;
}
.cdx-field {
    width: 300px;
}
.column {
    width: 300px;
}
</style>
